# Liste des contraintes

Le tableau ci-dessous liste les contraintes définissables dans Qualigéo

<table border="1px solid grey" style="padding=2px; border-color:grey;">
            <col style="width: auto;" />
            <col style="width: auto;" />
            <col style="width: auto;" />
            <col style="width: auto;" />
            <tr>
                <td>Contrainte</td>
                <td>Explication / Ressource</td>
                <td style="text-align: center;">Erreur(s) </td>
                <td style="text-align: center;">Libellé de l’erreur </td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte sur l’Interprétation de la géométrie</td>
                <td style="text-align: left;">
                    <p class="texte"> <span style="font-size: 10pt;">Vérifie les coordonnées des géométries et leur interprétation</span></p>
                    <p><a href="./03.02.TypeGeometrie.html" style="font-size: 8pt;">En savoir plus sur les contraintes d’inteprétation et de type de géométrie</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.01.DefinitionTypesEntites.html#type-de-geometrie-et-interpretation-de-la-geometrie">E0002</a>
                </td>
                <td style="text-align: left;">Géométrie non conforme (interprétation de la géométrie).</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte présence d’attribut  </td>
                <td style="text-align: left;">Vérifie la présence des attributs et détecte la présence d’attribut en trop. </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/02.04.CreationSchemaVierge.html#type-dentites-et-attribut-non-definis">E0003</a>
                </td>
                <td style="text-align: left;">Attribut non autorisé</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte d’existence obligatoire d’attribut </td>
                <td style="text-align: left;">Vérifie la présence des attributs et détecte l’absence d’attribut.</td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/02.04.CreationSchemaVierge.html#type-dentites-et-attribut-non-definis">E0004</a>
                </td>
                <td style="text-align: left;">Attribut obligatoire absent</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte d’existence d’un Type d’entité</td>
                <td style="text-align: left;">Vérifie la présence/absence de type d’entité</td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.01.DefinitionTypesEntites.html#existence">E0005 et E0006</a>
                </td>
                <td style="text-align: left;">Type d’entité obligatoire absent</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte sur la Longueur max d’attribut</td>
                <td style="text-align: left;">Vérifie la longueur des attributs</td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#longueur-dattribut/01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#longueur-dattribut">E0007</a>
                </td>
                <td style="text-align: left;">Taille de l’attribut trop grande</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte d’unicité</td>
                <td style="text-align: left;">Une contrainte d’unicité garantit l’unicité de données contenues dans un attribut. Elle exige que toutes les valeurs d’un attribut soient uniques. </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.03.DefinitionContraintesUnicite.html">E0008</a>
                </td>
                <td style="text-align: left;">Violation de la contrainte d’unicité</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte sur la nullité de  valeur </td>
                <td style="text-align: left;">Vérifie la nullité d’attribut</td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#valeur-obligatoire">E0009</a>
                </td>
                <td style="text-align: left;">Violation de contrainte de non nullité</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte sur domaine de valeurs </td>
                <td style="text-align: left;">Vérifie si les valeurs d’attributs sont dans une plage définie. </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#domaine-de-valeurs">E0010</a>
                </td>
                <td style="text-align: left;">Valeur d’attribut hors domaine</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de relation spatiale</td>
                <td style="text-align: left;">
                    <p class="texte" style="font-size: 10pt;">Vérifie les relations spatiales entre deux types d’entité </p>
                    <p style="font-size: 10pt;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/05.DefinitionContraintesRelationsSpatiales.html"><span style="font-size: 8pt;">En savoir plus sur les </span><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/05.DefinitionContraintesRelationsSpatiales.html" style="font-size: 8pt;">contraintes de relations spatiales </a></a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/05.DefinitionContraintesRelationsSpatiales.html">E0011</a>
                </td>
                <td style="text-align: left;">Violation de la contrainte de relation spatiale</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contraintes de Valeur d’attribut définie par Expression régulière</td>
                <td style="text-align: left;">
                    <p class="texte">Vérifie la valeur d’attribut</p>
                    <p><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#expression-reguliere" style="font-size: 8pt;">En savoir plus sur les contraintes définies pas expressions régulières</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#expression-reguliere">E0012</a>
                </td>
                <td style="text-align: left;">Valeur d’attribut hors expression régulière</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de tesselation </td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Vérifie la topologie entre entités</span>
                    </p>
                    <p><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.05.DefinitionContraintesTopologiques.html#caracteristiques-de-contraintes-topologique" style="font-size: 8pt;">En savoir plus sur les contraintes topologique (tesselation)</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.05.DefinitionContraintesTopologiques.html#caracteristiques-de-contraintes-topologique">E0014 et E0015</a>
                </td>
                <td style="text-align: left;">Violation de la contrainte de tesselation </td>
            </tr>
            <tr>
                <td style="text-align: left;">Contraintes de géométrie selon standards OGC&#160;</td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Vérifie la géométrie d’entités selon les normes définies par l’OGC</span>
                    </p>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.01.DefinitionTypesEntites.html#existence">E0018 à E0029</a>
                </td>
                <td style="text-align: left;">Géométrie non valide </td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de cardinalité</td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Vérifie les cardinalités entre types d’entité enfant et parents. </span>
                    </p>
                    <p><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/04.DefinitionContraintesCardinalites.html" style="font-size: 8pt;">En savoir plus sur les contraintes de cardinalités</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/04.DefinitionContraintesCardinalites.html">E0030 à E0033</a>
                </td>
                <td style="text-align: left;">Violation de la contrainte de cardinalité </td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de format date </td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Vérifie le formalisme des champs de type Date. </span>
                    </p>
                    <p><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#date" style="font-size: 8pt;">En savoir plus sur les formats de date</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#date">E0034</a>
                </td>
                <td style="text-align: left;">Date non conforme</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte spécifique sur type d’entité</td>
                <td style="text-align: left;">
                    <p class="texte" style="font-size: 10pt;">Appelle une fonction spécifique spécifiée par le Designer et retourne une erreur spécifique.</p>
                    <p><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.04.DefinitionContraintesSpecifiques.html#definition-de-contraintes-specifiques-sur-lentite-dans-larbre" style="font-size: 8pt;">En savoir plus sur les langages de définition de contraintes spécifiques</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.04.DefinitionContraintesSpecifiques.html#definition-de-contraintes-specifiques-sur-lentite-dans-larbre">E0035</a>
                </td>
                <td style="text-align: left;">Non respect d’une contrainte spécifique Type (définie par code) sur l’entité</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de domaine spatial - système de coordonnées de référence </td>
                <td style="text-align: left;">
                    <p class="texte" style="font-size: 10pt;">Vérifie l’étendue et le système de coordonnées d’un jeu de données. </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/02.04.CreationSchemaVierge.html#restreindre-a-un-systeme-de-coordonnees-de-reference">E0036 E0037</a>
                </td>
                <td style="text-align: left;">Non respect du domaine spatial. Système de coordonnées différent du système de référence.</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de type de géométrie</td>
                <td style="text-align: left;">
                    <p> <span style="font-size: 10pt;">Vérifie les coordonnées des géométries et leur interprétation. </span></p>
                    <p><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.01.DefinitionTypesEntites.html" style="font-size: 8pt;">En savoir plus sur les contraintes d’interprétation et de type de géométrie</a>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.01.DefinitionTypesEntites.html">E0038</a>
                </td>
                <td style="text-align: left;">Géométrie non conforme (type de géométrie).</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de plage de valeur numérique sur attribut </td>
                <td style="text-align: left;">Vérifie si les valeurs numériques d’attributs sont dans une plage définie. </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#valeur-numerique-min-et-max">E0039 et E0040</a>
                </td>
                <td style="text-align: left;">Valeur d’attribut inférieure au minimum</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de type d’attribut</td>
                <td style="text-align: left;">Vérifie le type des attributs (alphanumérique, entier, numérique). </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#type-dattributs">E0043</a>
                </td>
                <td style="text-align: left;">Type d’attribut non conforme</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de présence de Type d’entité</td>
                <td style="text-align: left;">Vérifie la présence /absence de type d’entité</td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/02.04.CreationSchemaVierge.html#type-dentites-et-attribut-non-definis">E0044</a>
                </td>
                <td style="text-align: left;">Type d’entité non défini</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte Python sur entité</td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Appelle une fonction spécifique sur une entité, créée par le Designer et retourne une erreur spécifique. </span>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.04.DefinitionContraintesSpecifiques.html#definition-de-contraintes-specifiques-sur-lentite-dans-larbre">E0045</a>
                </td>
                <td style="text-align: left;">Violation de la contrainte Python sur l’entité</td>
            </tr>
            <tr>
                <td style="text-align: left;">
                    <p style="font-size: 10pt;">Contrainte spécifique sur  valeur d’attribut (python)</p>
                    <p>&#160;</p>
                </td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Appelle une fonction spécifique sur un attribut, créée par le Designer et retourne une erreur spécifique.</span>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/03.02.DefinitionContraintesAttributs.html#contraintes-specifiques-sur-lattribut">E0047 </a>
                </td>
                <td style="text-align: left;">Valeur d’attribut hors expression régulière décrite par code python</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte spécifique sur jeu de données (pyhton)</td>
                <td style="text-align: left;">
                    <p><span style="font-size: 10pt;">Appelle une fonction spécifique sur un jeu de données, créée par le Designer et retourne une erreur spécifique.</span>
                    </p>
                </td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/07.DefinitionContraintesCode.html#edition-de-codes-tcl-et-python">E0048</a>
                </td>
                <td style="text-align: left;">Violation de la contrainte spécifique (Python) sur le jeu de données</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte de construction</td>
                <td style="text-align: left;">Vérifie la géométrie d’un type d’entité par rapport à la géométrie d’un type d’entité de référence. <p class="texte" style="font-weight: normal;"><span style="font-size: 8pt;"> </span><a href="../04-ContraintesRessources/03.03.ContraintesConstruction" style="font-size: 8pt;">En savoir plus sur les contraintes de construction</a></p></td>
                <td style="text-align: left;"><a href="../01-Utilisation de Qualigéo/02-SpecifierSchemaContraintes/02.04.CreationSchemaVierge.html">E0050 à E0052</a>
                </td>
                <td style="text-align: left;">Erreur de contrainte de construction</td>
            </tr>
            <tr>
                <td style="text-align: left;">Contrainte définie par format personnalisé </td>
                <td style="text-align: left;">
                    <p>&#160;</p>
                    <p><span style="font-size: 10pt;">Vérifie une contrainte définie via un format personnalisé importé dans Qualigéo</span>. </p>
                </td>
                <td style="text-align: left;">E0055
                </td>
                <td style="text-align: left;">Erreur définie et testée dans le format personnalisé</td>
            </tr>
        </table>
